/*
**    TP CPE Lyon
**    Copyright (C) 2014 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/



#ifndef OPENGL_DRAWER_HPP
#define OPENGL_DRAWER_HPP

#include <vector>


namespace cpe
{
  class mesh;
  class surface_param_drawable;
  class grid;
  class vec3;
  
  class opengl_drawer
  {
  public:
      static void draw(const mesh& m);
      static void draw(const surface_param_drawable& surf);
      static void draw(const grid& g);
      static void draw_sphere(const grid& g,const mesh& sphere);

      static void draw_curve(const std::vector<cpe::vec3>& curve);
      static void draw_curve(const std::vector<std::vector<cpe::vec3> >& curves);

  };
}

#endif
