/*
**    TP CPE Lyon
**    Copyright (C) 2014 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "evaluator_spline.hpp"
#include "../lib3d/vec4.hpp"

#include "../lib3d/matrix1x4.hpp"
#include "../lib3d/matrix4x1.hpp"


namespace cpe
{
evaluator_spline::evaluator_spline(const matrix4& P_param)
    :P(P_param)
{

}

float evaluator_spline::operator()(float u,float v) const
{
    //TO DO: calculer l'evaluation d'une surface de Bezier aux coordonnees (u,v)
    //
    // Modifier la formule suivante afin de d'evaluer un point de la surface
    //  S(u,v) avec S etant un patch de Bezier.
    //

    return (1-u)*(1-v)*P(0,0)+(1-u)*v*P(3,0)+u*(1-v)*P(0,3)+u*v*P(3,3);
}

float evaluator_spline::diff_u(float u,float v) const
{
    //TO DO: calculer l'evaluation de df/du pour une surface de Bezier aux coordonnees (u,v)
    //
    // Modifier la formule suivante afin de d'evaluer la derivee suivant u d'un point de la surface
    //  S(u,v) avec S etant un patch de Bezier.
    //

    return -(1-v)*P(0,0)-v*P(3,0)+(1-v)*P(0,3)+v*P(3,3);
}

float evaluator_spline::diff_v(float u,float v) const
{
    //TO DO: calculer l'evaluation de df/du pour une surface de Bezier aux coordonnees (u,v)
    //
    // Modifier la formule suivante afin de d'evaluer la derivee suivant v d'un point de la surface
    //  S(u,v) avec S etant un patch de Bezier.
    //

    return -(1-u)*P(0,0)+(1-u)*P(3,0)-u*P(0,3)+u*P(3,3);
}

}
